module IpWhitelist
  module Interceptor
    extend ActiveSupport::Concern

    included do
      rescue_from IpWhitelist::Error do |e|
        render json: { code: e.code, message: e.message }, status: e.status
      end
    end

    class_methods do
      def ip_interceptor appid, only: nil
        @@appid = appid
        only ? 
          before_action(:ip_intercept, only: only) :
          before_action(:ip_intercept)


        class_eval do
          private
          
          def ip_intercept
            p @@appid
            IpWhitelist::List.auth!(@@appid, request.ip)
          end
        end
      end
    end
  end
end

